<template>
	<mind-layout>
		<template slot="toolbar-actions">
			<el-radio-group v-model="rawMode"  size="small" style="margin-right: 20px; margin-bottom: 2px">
				<el-radio-button  :label="false"  title="Modo Formulario"><i class="el-icon-edit-outline"></i></el-radio-button>
				<el-radio-button :label="true" title="Modo RAW"><i class="el-icon-tickets" /></el-radio-button>
			</el-radio-group>
			<el-button type="primary" size="small" @click="onSubmit">Aplicar</el-button>
		</template>
		<mind-form :footer="false">
			<el-row wrap>
				<el-col :xs="24" :lg="12" :xl="8">
					<el-form-item  label="Nombre">
						<el-input v-model="recurso.category"></el-input>
					</el-form-item>
				</el-col>
				<el-col :xs="24" :lg="12" :xl="8">
					<el-form-item  label="Tipo de Troncal">
						<el-select v-model="recurso.type" >
							<el-option :disabled="!isNew"
								label="sip"
								value="sip" />
							<el-option
								label="iax"
								value="iax" />
						</el-select>
						<!-- <el-input disabled autosize v-model="recurso.type"></el-input> -->
					</el-form-item>
				</el-col>
			</el-row>
			<asterisk-context :mode="rawMode ? 'raw' : 'custom'" v-model="trunkData" :mnemonics="mnemonics" >
				<template v-slot="{context}">
					<el-row wrap >
						<el-col :xs="24" >
							<el-form-item  label="Descripción">
								<el-input  v-model="context.description"></el-input>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Tipo">
								<el-select v-model="context.type" >
									<el-option
										label="peer"
										value="peer" />
									<el-option
										label="friend"
										value="friend" />
								</el-select>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Contexto">
								<select-context v-model="context.context" filter="incoming-"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Destino">
								<el-input  v-model="context.host"></el-input>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Default IP">
								<input-array  v-model="context.defaultip"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Qualify">
								<el-select v-model="context.qualify"  >
									<el-option
										label="yes"
										value="yes" />
									<el-option
										label="no"
										value="no" />
								</el-select>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Origenes Permitidos">
								<input-array  v-model="context.permit"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="CallerID">
								<el-input  v-model="context.callerid"/>
							</el-form-item>
						</el-col>
					</el-row>
					<el-row>
						<el-divider>Codecs</el-divider>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Codecs">
								<select-codec v-model="context.allow" />
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Por Ancho de Banda">
								<el-select v-model="context.bandwidth"  >
									<el-option
										label="high"
										value="high" />
									<el-option
										label="medium"
										value="medium" />
									<el-option
										label="low"
										value="low" />
								</el-select>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8" v-if="recurso.type == 'iax'">
							<el-form-item  label="Prioridad de Codec">
								<el-select v-model="context.codecpriority"  >
									<el-option
										label="disabled"
										value="disabled" />
									<el-option
										label="caller"
										value="caller" />
									<el-option
										label="host"
										value="host" />
									<el-option
										label="reqonly"
										value="reqonly" />
								</el-select>
							</el-form-item>
						</el-col>
					</el-row>
					<el-divider>Autenticación</el-divider>
					<el-row>
						<el-col :xs="24" :lg="12" :xl="8" v-if="recurso.type == 'iax'">
							<el-form-item  label="Tipo de Autenticación">
								<select-auth v-model="context.auth" />
							</el-form-item>
						</el-col>
						<!-- <el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Usuario Remoto">
								<el-input type="password" v-model="context.username"/>
							</el-form-item>
						</el-col> -->
						<el-col :xs="24" :lg="12" :xl="8">
							<el-form-item  label="Contraseña">
								<el-input type="password" v-model="context.secret"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8" v-if="recurso.type == 'sip'">
							<el-form-item  label="Contraseña (MD5)">
								<el-input type="password" v-model="context.md5secret"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8" v-if="recurso.type == 'sip'">
							<el-form-item  label="Contraseña Remota">
								<el-input type="password" v-model="context.remotesecret"/>
							</el-form-item>
						</el-col>
						<el-col :xs="24" :lg="12" :xl="8" v-if="recurso.type == 'iax'">
							<el-form-item  label="DB Secret">
								<el-input type="text" v-model="context.dbsecret"/>
							</el-form-item>
						</el-col>
					</el-row>
					<el-divider>Avanzado</el-divider>
					<template v-if="recurso.type == 'sip'">
						<el-row >
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="NAT">
									<el-select v-model="context.nat"  >
										<el-option
											label="yes"
											value="yes" />
										<el-option
											label="no"
											value="no" />
										<el-option
											label="force_rport"
											value="force_rport" />
										<el-option
											label="comedia"
											value="comedia" />
									</el-select>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Call Limit">
									<el-input type="number" clearable v-model="context['call-limit']"/>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="REINVITES">
									<el-select v-model="context.directmedia"  >
										<el-option
											label="yes"
											value="yes" />
										<el-option
											label="no"
											value="no" />
										<el-option
											label="nonat"
											value="nonat" />
										<el-option
											label="update"
											value="update" />
									</el-select>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Modo DTMF">
									<el-select v-model="context.dtmfmode"  >
										<el-option
											label="info"
											value="info" />
										<el-option
											label="inband"
											value="inband" />
										<el-option
											label="rfc2833"
											value="rfc2833" />
									</el-select>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="From User">
									<el-input v-model="context.fromuser"/>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="From Domain">
									<el-input v-model="context.fromuser"/>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Insecure">
									<el-select v-model="context.insecure" style="width:100%" >
										<el-option label="port" value="port"  />
										<el-option label="invite" value="invite"  />
										<el-option label="yes" value="yes" />
										<!-- <el-option label="no" value="" /> -->
									</el-select>
								</el-form-item>
							</el-col>

						</el-row>
					</template>
					<template v-if="recurso.type == 'iax'">
						<el-row>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Debug Autenticación">
									<el-select v-model="context.authdebug"  >
										<el-option
											label="yes"
											value="yes" />
										<el-option
											label="no"
											value="no" />
									</el-select>
								</el-form-item>
							</el-col>
							<el-col :xs="24" :lg="12" :xl="8">
								<el-form-item  label="Jitter Buffer">
									<el-select v-model="context.jitterbuffer"  >
										<el-option
											label="yes"
											value="yes" />
										<el-option
											label="no"
											value="no" />
									</el-select>
								</el-form-item>
							</el-col>
						</el-row>
					</template>
				</template>
			</asterisk-context>
		</mind-form>
	</mind-layout>
</template>
<script>
import {Rest} from '@/../modules/mind-core-vue'
import asteriskContext from '@/components/asterisk-context'
import mnemonics from '@/mnemonics/sip-trunk'
import selectContext from '@/components/select-context'
import selectCodec from '@/components/select-codec'
import selectAuth from '@/components/select-authtype'
import inputArray from '@/components/input-array'

export default {
	components: {
		asteriskContext,
		selectCodec,
		inputArray,
		selectAuth,
		selectContext
	},
	async created(){
		let type = this.$route.params.type
		let id = this.$route.params.id
		this.api = new Rest({
			uri: `api/ami/trunks/${type}`, 
			key: 'name'
		})

		this.trunkName = id
		if(!id || id == 'new') {
			this.isNew = true
			this.recurso = {	}
		} else {
			const recurso = await this.api.Fetch(id)
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
			this.recurso = recurso
		}
	},
	computed:{
		trunkData:{
			get(){
				return this.recurso.options || []
			},
			set(v) {
				this.recurso.options = v
			}
		},
		mnemonics() {
			return mnemonics
		}
	},

	methods: {
		async onSubmit() {
			if(this.recurso.type == 'iax') {
				const found = this.recurso.options.find( r=> r.indexOf('trunk') == 0)
				if(!found) {
					this.recurso.options.push("trunk=yes")
				}
			}

			if(this.isNew) {
				this.api.Post(this.recurso, {uri: `api/ami/trunks`})
					.then(()=>{
						this.$message({
							showClose: true,
							type: 'success',
							message: "Troncal creada"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})

			} else {
				this.api.Patch(this.recurso, this.trunkName)
					.then(()=>{
						this.$message({
							showClose: true,
							type: 'success',
							message: "Se aplicaron los cambios"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})

			}
		}
	},
	filters: {
		join(v) {
			if(Array.isArray(v)) {
				return v.join(', ')
			}
			return v
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {
			},
			api: null,
			trunkName: null,
			rawMode: false
		}
	}
}
</script>
<style lang="css" >
.el-select {
	width:100%;
}
</style>